#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <locale.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

double solde;
double check_solde;
char nom_fichier[100];
char nom_fichier_ps[100];
int change;

gboolean
on_window1_delete_event                (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  GtkWidget *win_choix;
  GtkWidget *lbl_choix;
  GtkWidget *choix_ok;
  GtkWidget *choix_cancel;
  action *act;

  act = (action*)malloc(sizeof(action));
  act->widget = lookup_widget(GTK_WIDGET(widget), "list_op");
  act->type = 3;
  if(change)
    {
      win_choix = create_win_choix();
      lbl_choix = lookup_widget(win_choix, "lbl_choix");
      choix_ok = lookup_widget(win_choix, "choix_ok");
      choix_cancel = lookup_widget(win_choix, "choix_cancel");
      gtk_label_set(GTK_LABEL(lbl_choix),  _("File Not Save !\nDo you want to save ?"));
      gtk_signal_connect (GTK_OBJECT (choix_ok), "clicked",
			  GTK_SIGNAL_FUNC (on_choix_ok_clicked),
			  act);
      gtk_signal_connect (GTK_OBJECT (choix_cancel), "clicked",
			  GTK_SIGNAL_FUNC (on_choix_cancel_clicked),
			  act);
      gtk_widget_show(win_choix);
      return TRUE;
    }
  else
    {
      gtk_main_quit();
      return FALSE;
    }
}


void
on_nouveau1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *list_op;
  GtkWidget *win_choix;
  GtkWidget *lbl_choix;
  GtkWidget *choix_ok;
  GtkWidget *choix_cancel;
  action *act;

  list_op = lookup_widget(GTK_WIDGET(menuitem), "list_op");
  act =(action*)malloc(sizeof(action));
  act->widget = list_op;

  if(change)
    {
      act->type = 1;
      win_choix = create_win_choix();
      lbl_choix = lookup_widget(win_choix, "lbl_choix");
      choix_ok = lookup_widget(win_choix, "choix_ok");
      choix_cancel = lookup_widget(win_choix, "choix_cancel");
      gtk_label_set(GTK_LABEL(lbl_choix),  _("File Not Save !\nDo you want to save ?"));
      gtk_signal_connect (GTK_OBJECT (choix_ok), "clicked",
			  GTK_SIGNAL_FUNC (on_choix_ok_clicked),
			  act);
      gtk_signal_connect (GTK_OBJECT (choix_cancel), "clicked",
			  GTK_SIGNAL_FUNC (on_choix_cancel_clicked),
			  act);
      gtk_widget_show(win_choix);
    }
  else
    {
      gtk_clist_clear(GTK_CLIST(list_op));
      solde = 0;
    }
}


void
on_ouvrir1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *fileselection1;
  GtkWidget *win_choix;
  GtkWidget *lbl_choix;
  GtkWidget *choix_ok;
  GtkWidget *choix_cancel;
  GtkWidget *list_op;
  action *act;

  list_op = lookup_widget(GTK_WIDGET(menuitem), "list_op");
  act =(action*)malloc(sizeof(action));
  act->widget = list_op;

  if(change)
    {
      act->type = 2;
      win_choix = create_win_choix();
      lbl_choix = lookup_widget(win_choix, "lbl_choix");
      choix_ok = lookup_widget(win_choix, "choix_ok");
      choix_cancel = lookup_widget(win_choix, "choix_cancel");
      gtk_label_set(GTK_LABEL(lbl_choix),  _("File Not Save !\nDo you want to save ?"));
      gtk_signal_connect (GTK_OBJECT (choix_ok), "clicked",
			  GTK_SIGNAL_FUNC (on_choix_ok_clicked),
			  act);
      gtk_signal_connect (GTK_OBJECT (choix_cancel), "clicked",
			  GTK_SIGNAL_FUNC (on_choix_cancel_clicked),
			  act);
      gtk_widget_show(win_choix);
    }
  else
    {
      act->type = 2;
      gtk_clist_clear(GTK_CLIST(list_op));
      solde = 0;
      fileselection1 = create_fileselection1 ();
      gtk_signal_connect (GTK_OBJECT(GTK_FILE_SELECTION(fileselection1)->ok_button),
			  "clicked",
			  (GtkSignalFunc)ok_select, act);
      gtk_widget_show (fileselection1);
    }
}


void
on_enregistrer1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *clist1;
  GtkWidget *fileselection1;
  action *act;
  act = (action *)malloc(sizeof(action));

  clist1 = lookup_widget(GTK_WIDGET(menuitem), "list_op");
  act->widget = clist1;
  act->type = 0;
  if(!strcmp(nom_fichier, ""))
    {  
      fileselection1 = create_fileselection1 ();
      gtk_signal_connect (
	     GTK_OBJECT(GTK_FILE_SELECTION(fileselection1)->ok_button),
	     "clicked",
	      (GtkSignalFunc)ok_select, act);
	      gtk_widget_show (fileselection1);
    }
  else
    enregistrer(GTK_CLIST(clist1));
}

void
on_exporter_latex1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *clist1;
  GtkWidget *fileselection1;

  clist1 = lookup_widget(GTK_WIDGET(menuitem), "list_op");
  fileselection1 = create_fileselection1 ();
  gtk_signal_connect (GTK_OBJECT(GTK_FILE_SELECTION(fileselection1)->ok_button)
		      ,"clicked",(GtkSignalFunc)save_nom_latex, clist1);
  gtk_widget_show (fileselection1);
}


void
on_exporter_html1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *clist1;
  GtkWidget *fileselection1;

  clist1 = lookup_widget(GTK_WIDGET(menuitem), "list_op");
  fileselection1 = create_fileselection1 ();
  gtk_signal_connect (GTK_OBJECT(GTK_FILE_SELECTION(fileselection1)->ok_button)
		      ,"clicked",(GtkSignalFunc)save_nom_html, clist1);
  gtk_widget_show (fileselection1);
}


void
on_quitter1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *win_choix;
  GtkWidget *lbl_choix;
  GtkWidget *choix_ok;
  GtkWidget *choix_cancel;
  action *act;

  act = (action*)malloc(sizeof(action));
  act->widget = lookup_widget(GTK_WIDGET(menuitem), "list_op");
  act->type = 3;
  if(change)
    {
      win_choix = create_win_choix();
      lbl_choix = lookup_widget(win_choix, "lbl_choix");
      choix_ok = lookup_widget(win_choix, "choix_ok");
      choix_cancel = lookup_widget(win_choix, "choix_cancel");
      gtk_label_set(GTK_LABEL(lbl_choix),  _("File Not Save !\nDo you want to save ?"));
      gtk_signal_connect (GTK_OBJECT (choix_ok), "clicked",
			  GTK_SIGNAL_FUNC (on_choix_ok_clicked),
			  act);
      gtk_signal_connect (GTK_OBJECT (choix_cancel), "clicked",
			  GTK_SIGNAL_FUNC (on_choix_cancel_clicked),
			  act);
      gtk_widget_show(win_choix);
    }
  else
    {
      gtk_main_quit();
    }
}


void
on_ajouter_une_op_ration2_activate     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *win_saisie;
  win_saisie = create_win_saisie (GTK_WIDGET(user_data));
  gtk_widget_show (win_saisie);
}

void
on_supprimer_operation_activate        (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *list_op;
  change = 1;
  /*suppression de la ligne selectionnee */
  list_op = lookup_widget(GTK_WIDGET(menuitem), "list_op");
  gtk_clist_remove(GTK_CLIST(list_op), GTK_CLIST(list_op)->focus_row);
  /*il faut recalculer les soldes*/
  recalcule_solde(GTK_CLIST(list_op));
  // il faut recalculer la balance
}

void
on_d_bit_automatique1_activate         (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_cr_dit_automatique1_activate        (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_a_propos1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *dlg_about;
  dlg_about = create_dlg_about ();
  gtk_widget_show (dlg_about);
}

void
on_btn_operation_clicked              (GtkButton       *button,
                                       gpointer         user_data)
{
  GtkWidget *win_saisie;
  win_saisie = create_win_saisie (GTK_WIDGET(user_data));
  gtk_widget_show (win_saisie);
}

void
on_btn_delete_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_clist_remove(GTK_CLIST(user_data), GTK_CLIST(user_data)->focus_row);
  /*il faut recalculer les soldes*/
  recalcule_solde(GTK_CLIST(user_data));
  change = 1;
  // il faut recalculer la balance
}

void
on_btn_nouveau_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *list_op;
  GtkWidget *win_choix;
  GtkWidget *lbl_choix;
  GtkWidget *choix_ok;
  GtkWidget *choix_cancel;
  action *act;

  list_op = lookup_widget(GTK_WIDGET(button), "list_op");
  act =(action*)malloc(sizeof(action));
  act->widget = list_op;

  if(change)
    {
      act->type = 1;
      win_choix = create_win_choix();
      lbl_choix = lookup_widget(win_choix, "lbl_choix");
      choix_ok = lookup_widget(win_choix, "choix_ok");
      choix_cancel = lookup_widget(win_choix, "choix_cancel");
      gtk_label_set(GTK_LABEL(lbl_choix),  _("File Not Save !\nDo you want to save ?"));
      gtk_signal_connect (GTK_OBJECT (choix_ok), "clicked",
			  GTK_SIGNAL_FUNC (on_choix_ok_clicked),
			  act);
      gtk_signal_connect (GTK_OBJECT (choix_cancel), "clicked",
			  GTK_SIGNAL_FUNC (on_choix_cancel_clicked),
			  act);
      gtk_widget_show(win_choix);
    }
  else
    {
      gtk_clist_clear(GTK_CLIST(list_op));
      solde = 0;
    }
}

void
on_btn_ouvrir_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *fileselection1;
  GtkWidget *win_choix;
  GtkWidget *lbl_choix;
  GtkWidget *choix_ok;
  GtkWidget *choix_cancel;
  GtkWidget *list_op;
  action *act;

  list_op = lookup_widget(GTK_WIDGET(button), "list_op");
  act =(action*)malloc(sizeof(action));
  act->widget = list_op;

  if(change)
    {
      act->type = 2;
      win_choix = create_win_choix();
      lbl_choix = lookup_widget(win_choix, "lbl_choix");
      choix_ok = lookup_widget(win_choix, "choix_ok");
      choix_cancel = lookup_widget(win_choix, "choix_cancel");
      gtk_label_set(GTK_LABEL(lbl_choix),  _("File Not Save !\nDo you want to save ?"));
      gtk_signal_connect (GTK_OBJECT (choix_ok), "clicked",
			  GTK_SIGNAL_FUNC (on_choix_ok_clicked),
			  act);
      gtk_signal_connect (GTK_OBJECT (choix_cancel), "clicked",
			  GTK_SIGNAL_FUNC (on_choix_cancel_clicked),
			  act);
      gtk_widget_show(win_choix);
    }
  else
    {
      act->type = 2;
      gtk_clist_clear(GTK_CLIST(list_op));
      solde = 0;
      fileselection1 = create_fileselection1 ();
      gtk_signal_connect (GTK_OBJECT(GTK_FILE_SELECTION(fileselection1)->ok_button),
			  "clicked",
			  (GtkSignalFunc)ok_select, act);
      gtk_widget_show (fileselection1);
    }
}

void
on_btn_enregister_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *clist1;
  GtkWidget *fileselection1;
  action *act;
  act = (action *)malloc(sizeof(action));
  
  clist1 = lookup_widget(GTK_WIDGET(button), "list_op");
  act->widget = clist1;
  act->type = 0;
  if(!strcmp(nom_fichier, ""))
    {  
      fileselection1 = create_fileselection1 ();
      gtk_signal_connect (
	     GTK_OBJECT(GTK_FILE_SELECTION(fileselection1)->ok_button),
	     "clicked",
	      (GtkSignalFunc)ok_select, act);
	      gtk_widget_show (fileselection1);

    }
  else
    enregistrer(GTK_CLIST(clist1));

}

//user_data pointer sur list_op
void
on_btn_check_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *win_rapproch;
  GtkWidget *bouton3;
  GtkWidget *bouton2;
  GtkWidget *bouton4;
  GtkWidget *list_op2;
  GtkWidget *list_op;
  GtkWidget *rapproch;
  gint i, k, is_image;
  GdkPixmap *old_pixmap;
  GdkBitmap *old_mask;
  gchar *buffer[7];
  gchar tampon[10];
  gint *data;
  double check_solde;

  list_op = GTK_WIDGET(user_data);
  win_rapproch = create_win_rapproch();
  bouton3 = lookup_widget(GTK_WIDGET(win_rapproch), "button3");
  bouton2 = lookup_widget(GTK_WIDGET(win_rapproch), "bouton2");
  list_op2 = lookup_widget(GTK_WIDGET(win_rapproch), "list_op2");
  rapproch = lookup_widget(GTK_WIDGET(win_rapproch), "entry2");
  bouton4 = lookup_widget(GTK_WIDGET(win_rapproch), "button4");
  //remplissage de la liste de la nouvelle fentre
  for(i=0; i< GTK_CLIST(list_op)->rows; i++)
    {
      is_image = gtk_clist_get_pixmap(GTK_CLIST(list_op), i, 6, &old_pixmap, &old_mask);
      if(!is_image)
	{
	  for(k=0; k<5; k++)
	      gtk_clist_get_text(GTK_CLIST(list_op), i, k, &buffer[k]);
	  buffer[6] = malloc(2*sizeof(char));
	  strcpy(buffer[6], "");
	  gtk_clist_append(GTK_CLIST(list_op2), buffer);
	  data = g_malloc(sizeof(int));
	  *data = i;
	  gtk_clist_set_row_data(GTK_CLIST(list_op2), GTK_CLIST(list_op2)->rows -1, data);
	}
    }
  // on place le montant de la balance
  check_solde = calcul_check(list_op);
  sprintf(tampon, "%.2f", (float)check_solde);
  gtk_entry_set_text(GTK_ENTRY(rapproch), tampon);
  //on colorize les lignes
  ligne_color(list_op2);
  //ajout d'evenement pour le bouton check
  gtk_signal_connect (GTK_OBJECT (bouton3), "clicked",
                      GTK_SIGNAL_FUNC (on_check_operation_clicked),
                      user_data);
  gtk_signal_connect (GTK_OBJECT (bouton2), "clicked",
                      GTK_SIGNAL_FUNC (on_termine_clicked),
                      user_data);
  gtk_signal_connect (GTK_OBJECT (bouton4), "clicked",
                      GTK_SIGNAL_FUNC (on_update_clicked),
                      user_data);

  gtk_widget_show(win_rapproch);
}

void
on_check_operation_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *button_check;
  button_check = lookup_widget(GTK_WIDGET(menuitem), "btn_check");
  on_btn_check_clicked(GTK_BUTTON(button_check), user_data);
}

void
on_exporter_csv_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *clist1;
  GtkWidget *fileselection1;

  clist1 = lookup_widget(GTK_WIDGET(menuitem), "list_op");
  fileselection1 = create_fileselection1 ();
  gtk_signal_connect (GTK_OBJECT(GTK_FILE_SELECTION(fileselection1)->ok_button)
		      ,"clicked",(GtkSignalFunc)save_nom_csv, clist1);
  gtk_widget_show (fileselection1);

}















































