#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <locale.h>
#include <unistd.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

extern double solde;
extern char nom_fichier[100];
extern char nom_fichier_ps[100];


void
save_nom_latex                              (GtkButton       *button,
                                       gpointer         user_data)  
{
  GtkWidget *fileselection1;
  GtkWidget *dlg_mess;
  GtkWidget *lbl_mess;
  FILE *ptr_fic;
  
  fileselection1 = lookup_widget(GTK_WIDGET(button),"fileselection1");
  strcpy(nom_fichier_ps, gtk_file_selection_get_filename(GTK_FILE_SELECTION(fileselection1)));
  /*g_print("%s\n",nom_fichier);*/
  gtk_widget_destroy(GTK_WIDGET(fileselection1));
  if((ptr_fic = fopen(nom_fichier_ps, "a")))
    {
      fclose(ptr_fic);
      enreg_latex(GTK_CLIST(user_data));
    }
  else
    {
      dlg_mess = create_dlg_message ();
      lbl_mess = lookup_widget(GTK_WIDGET(dlg_mess), "lbl_info");
      gtk_label_set(GTK_LABEL(lbl_mess), "Nom de fichier non valide");
      gtk_widget_show(dlg_mess);
      strcpy(nom_fichier, "");
    }
} 

void 
enreg_latex                     (GtkCList        *list_op)
{
  FILE *ptr_fic;
  char *tampon;
  int colonne=0;

  ptr_fic = fopen(nom_fichier_ps, "w");  
  if(ptr_fic)
    {
      fputs("\\documentclass[12pt,a4paper]{book}\n", ptr_fic);
      fputs("\\usepackage[latin1]{inputenc}\n", ptr_fic);
      fputs("\\usepackage[french]{babel}\n", ptr_fic);
      fputs("\\usepackage[a4paper,twoside]{geometry}\n", ptr_fic);
      fputs("\\usepackage[T1]{fontenc}\n", ptr_fic);
      fputs("\\pagestyle{empty}\n", ptr_fic);
      fputs("\\begin{document}\n", ptr_fic);
      fputs("\\begin{tabular}{|c|l|r|r|c|r|}\n", ptr_fic);
      fputs("\\hline\n", ptr_fic);
      while(gtk_clist_get_text(GTK_CLIST(list_op), colonne, 0, &tampon))
	{
	  esc_latex(ptr_fic, tampon);
	  fprintf(ptr_fic, "&");
	  gtk_clist_get_text(GTK_CLIST(list_op), colonne, 1, &tampon);
	  esc_latex(ptr_fic, tampon);
	  fprintf(ptr_fic, "&");
	  gtk_clist_get_text(GTK_CLIST(list_op), colonne, 2, &tampon);
	  esc_latex(ptr_fic, tampon);
	  fprintf(ptr_fic, "&");
	  gtk_clist_get_text(GTK_CLIST(list_op), colonne, 3, &tampon);
	  esc_latex(ptr_fic, tampon);
	  fprintf(ptr_fic, "&");
	  gtk_clist_get_text(GTK_CLIST(list_op), colonne, 4, &tampon);
	  esc_latex(ptr_fic, tampon);
	  fprintf(ptr_fic, "&");
	  gtk_clist_get_text(GTK_CLIST(list_op), colonne, 5, &tampon);
	  esc_latex(ptr_fic, tampon);
	  fprintf(ptr_fic, "\\\\\n\\hline\n");	  
	  colonne++;
	}
      fputs("\\end{tabular}\n", ptr_fic);
      fputs("\\end{document}\n", ptr_fic);
      fclose(ptr_fic);
    }
  else
    {
      g_print("erreur d'ecriture dans le fichier %s\n", nom_fichier);
    }
}

void esc_latex(FILE *ptr_fic, char *text)
{
  gchar reqesc[] = "&#${}";  gchar * c;

  for (c = text; *c; ++c)
  {
    if (strchr(reqesc, *c) != NULL)
      fprintf(ptr_fic, "\\%c", *c);
    else
      fprintf(ptr_fic, "%c", *c);
  }
}










