#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <locale.h>
#include <ctype.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

extern double solde;
extern char nom_fichier[100];
extern char nom_fichier_ps[100];


void
affiche_check(gint row, gint column, GtkWidget *list_op)
{
  GdkPixmap *pixmap;
  GdkBitmap *mask;

  pixmap = gdk_pixmap_create_from_xpm(list_op->window,
				      &mask,
				      NULL,
				      PACKAGE_DATA_DIR "/pixmaps/c.xpm");
  if(pixmap == NULL)
    {
      pixmap = gdk_pixmap_create_from_xpm(list_op->window,
					  &mask,
					  NULL,
					  "../pixmaps/c.xpm");
    }
  if(pixmap == NULL)
    {
      g_print("erreur d'ouverture de la pixmap\n");
      return;
    }
  gtk_clist_set_pixmap(GTK_CLIST(list_op),row, column, pixmap, mask);
  gdk_pixmap_unref(pixmap);
}

void
cache_check(gint row, gint column, GtkWidget *list_op)
{
      gtk_clist_set_text(GTK_CLIST(list_op), row, column, NULL);        
}

void
ligne_color(GtkWidget *list_op)
{
  GdkColor couleur2;
  GdkColor couleur3;

  int i=0;

  couleur2.red = 51200;
  couleur2.green = 65535;
  couleur2.blue = 46080;

  couleur3.red = 65535;
  couleur3.green = 65535;
  couleur3.blue = 65535;

  gtk_clist_freeze(GTK_CLIST(list_op));
  
  for(i=0; i<GTK_CLIST(list_op)->rows; i++)
    {
      if(i%2 == 0)
	  gtk_clist_set_background(GTK_CLIST(list_op), i, &couleur2);
      else
	  gtk_clist_set_background(GTK_CLIST(list_op), i, &couleur3);	
    }
  gtk_clist_thaw(GTK_CLIST(list_op));
}

void
 insert_text_handler (GtkEditable *editable,
                      const gchar *text,
                      gint         length,
                      gint        *position,
                      gpointer     data)
 {
   int i;
   gchar *result = g_new (gchar, length);

   for (i=0; i<length; i++)
     {
       strcpy(result, "");
       if(isdigit(text[i]))
	 result[i] = text[i];
       if(text[i] == '.' || text[i] == ',')
	 {
	   if(!(strstr(gtk_entry_get_text(GTK_ENTRY(editable)), ".")) && !(strstr(gtk_entry_get_text(GTK_ENTRY(editable)), ",")))
	     result[i] = text[i];
	 }
     }
   gtk_signal_handler_block_by_func (GTK_OBJECT (editable),
                                     GTK_SIGNAL_FUNC (insert_text_handler),
                                     data);
   gtk_editable_insert_text (editable, result, length, position);
   gtk_signal_handler_unblock_by_func (GTK_OBJECT (editable),
                                       GTK_SIGNAL_FUNC (insert_text_handler),
                                       data);

   gtk_signal_emit_stop_by_name (GTK_OBJECT (editable), "insert_text");

   g_free (result);
 }
