#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "interface.h"
#include "callbacks.h"
#include "support.h"

GtkWidget*
create_win_main ()
{
  GtkWidget *win_main;
  GtkWidget *vbox1;
  GtkWidget *menubar1;
  GtkWidget *fichier1;
  GtkWidget *fichier1_menu;
  GtkWidget *nouveau1;
  GtkWidget *ouvrir1;
  GtkWidget *enregistrer1;
  GtkWidget *s_parateur1;
  GtkWidget *exporter_latex1;
  GtkWidget *exporter_html1;
  GtkWidget *exporter_csv;
  GtkWidget *s_parateur2;
  GtkWidget *quitter1;
  GtkWidget *edition1;
  GtkWidget *edition1_menu;
  GtkWidget *ajouter_une_op_ration2;
  GtkWidget *supprimer_operation;
  GtkWidget *check_operation;
  GtkWidget *s_parateur3;
  GtkWidget *d_bit_automatique1;
  GtkWidget *cr_dit_automatique1;
  GtkWidget *aide1;
  GtkWidget *aide1_menu;
  GtkWidget *a_propos1;
  GtkWidget *toolbar1;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *btn_nouveau;
  GtkWidget *btn_ouvrir;
  GtkWidget *btn_enregister;
  GtkWidget *btn_quit;
  GtkWidget *btn_operation;
  GtkWidget *btn_check;
  GtkWidget *btn_delete;
  GtkWidget *scrolledwindow1;
  GtkWidget *list_op;
  GtkWidget *lbl_date;
  GtkWidget *lbl_libel;
  GtkWidget *lbl_debit;
  GtkWidget *lbl_credit;
  GtkWidget *lbl_type;
  GtkWidget *lbl_solde;
  GtkWidget *lbl_check;
  GtkWidget *statusbar1;

  win_main = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (win_main), "win_main", win_main);
  gtk_widget_set_usize (win_main, 650, 230);
  gtk_window_set_title (GTK_WINDOW (win_main), _("Gcompte : manage your personnal finance"));

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (win_main), "vbox1", vbox1);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (win_main), vbox1);

  menubar1 = gtk_menu_bar_new ();
  gtk_object_set_data (GTK_OBJECT (win_main), "menubar1", menubar1);
  gtk_widget_show (menubar1);
  gtk_box_pack_start (GTK_BOX (vbox1), menubar1, FALSE, FALSE, 0);
  gtk_widget_set_usize (menubar1, 230, -2);

  fichier1 = gtk_menu_item_new_with_label (_("File"));
  gtk_object_set_data (GTK_OBJECT (win_main), "fichier1", fichier1);
  gtk_widget_show (fichier1);
  gtk_container_add (GTK_CONTAINER (menubar1), fichier1);

  fichier1_menu = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (win_main), "fichier1_menu", fichier1_menu);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (fichier1), fichier1_menu);

  nouveau1 = gtk_menu_item_new_with_label (_("New"));
  gtk_object_set_data (GTK_OBJECT (win_main), "nouveau1", nouveau1);
  gtk_widget_show (nouveau1);
  gtk_container_add (GTK_CONTAINER (fichier1_menu), nouveau1);

  ouvrir1 = gtk_menu_item_new_with_label (_("Open"));
  gtk_object_set_data (GTK_OBJECT (win_main), "ouvrir1", ouvrir1);
  gtk_widget_show (ouvrir1);
  gtk_container_add (GTK_CONTAINER (fichier1_menu), ouvrir1);

  enregistrer1 = gtk_menu_item_new_with_label (_("Save"));
  gtk_object_set_data (GTK_OBJECT (win_main), "enregistrer1", enregistrer1);
  gtk_widget_show (enregistrer1);
  gtk_container_add (GTK_CONTAINER (fichier1_menu), enregistrer1);

  s_parateur1 = gtk_menu_item_new ();
  gtk_object_set_data (GTK_OBJECT (win_main), "s_parateur1", s_parateur1);
  gtk_widget_show (s_parateur1);
  gtk_container_add (GTK_CONTAINER (fichier1_menu), s_parateur1);

  exporter_latex1 = gtk_menu_item_new_with_label (_("Export LateX"));
  gtk_object_set_data (GTK_OBJECT (win_main), "exporter_latex1", exporter_latex1);
  gtk_widget_show (exporter_latex1);
  gtk_container_add (GTK_CONTAINER (fichier1_menu), exporter_latex1);

  exporter_html1 = gtk_menu_item_new_with_label (_("Export HTML"));
  gtk_object_set_data (GTK_OBJECT (win_main), "exporter_html1", exporter_html1);
  gtk_widget_show (exporter_html1);
  gtk_container_add (GTK_CONTAINER (fichier1_menu), exporter_html1);

  exporter_csv = gtk_menu_item_new_with_label (_("Export CSV"));
  gtk_object_set_data (GTK_OBJECT (win_main), "exporter_csv", exporter_csv);
  gtk_widget_show (exporter_csv);
  gtk_container_add (GTK_CONTAINER (fichier1_menu), exporter_csv);

  s_parateur2 = gtk_menu_item_new ();
  gtk_object_set_data (GTK_OBJECT (win_main), "s_parateur2", s_parateur2);
  gtk_widget_show (s_parateur2);
  gtk_container_add (GTK_CONTAINER (fichier1_menu), s_parateur2);

  quitter1 = gtk_menu_item_new_with_label (_("Quit"));
  gtk_object_set_data (GTK_OBJECT (win_main), "quitter1", quitter1);
  gtk_widget_show (quitter1);
  gtk_container_add (GTK_CONTAINER (fichier1_menu), quitter1);

  edition1 = gtk_menu_item_new_with_label (_("Edit"));
  gtk_object_set_data (GTK_OBJECT (win_main), "edition1", edition1);
  gtk_widget_show (edition1);
  gtk_container_add (GTK_CONTAINER (menubar1), edition1);

  edition1_menu = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (win_main), "edition1_menu", edition1_menu);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (edition1), edition1_menu);

  ajouter_une_op_ration2 = gtk_menu_item_new_with_label (_("Add an operation"));
  gtk_object_set_data (GTK_OBJECT (win_main), "ajouter_une_op_ration2", ajouter_une_op_ration2);
  gtk_widget_show (ajouter_une_op_ration2);
  gtk_container_add (GTK_CONTAINER (edition1_menu), ajouter_une_op_ration2);

  supprimer_operation = gtk_menu_item_new_with_label (_("Delete an operation"));
  gtk_object_set_data (GTK_OBJECT (win_main), "supprimer_operation", supprimer_operation);
  gtk_widget_show (supprimer_operation);
  gtk_container_add (GTK_CONTAINER (edition1_menu), supprimer_operation);

  check_operation = gtk_menu_item_new_with_label (_("Balance calcul"));
  gtk_object_set_data (GTK_OBJECT (win_main), "check_operation", check_operation);
  gtk_widget_show (check_operation);
  gtk_container_add (GTK_CONTAINER (edition1_menu), check_operation);

  s_parateur3 = gtk_menu_item_new ();
  gtk_object_set_data (GTK_OBJECT (win_main), "s_parateur3", s_parateur3);
  gtk_widget_show (s_parateur3);
  gtk_container_add (GTK_CONTAINER (edition1_menu), s_parateur3);

  d_bit_automatique1 = gtk_menu_item_new_with_label (_("Automatic Debit"));
  gtk_object_set_data (GTK_OBJECT (win_main), "d_bit_automatique1", d_bit_automatique1);
  gtk_widget_show (d_bit_automatique1);
  gtk_container_add (GTK_CONTAINER (edition1_menu), d_bit_automatique1);

  cr_dit_automatique1 = gtk_menu_item_new_with_label (_("Automatic Credit"));
  gtk_object_set_data (GTK_OBJECT (win_main), "cr_dit_automatique1", cr_dit_automatique1);
  gtk_widget_show (cr_dit_automatique1);
  gtk_container_add (GTK_CONTAINER (edition1_menu), cr_dit_automatique1);

  aide1 = gtk_menu_item_new_with_label (_("Help"));
  gtk_object_set_data (GTK_OBJECT (win_main), "aide1", aide1);
  gtk_widget_show (aide1);
  gtk_container_add (GTK_CONTAINER (menubar1), aide1);
  gtk_menu_item_right_justify (GTK_MENU_ITEM (aide1));

  aide1_menu = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (win_main), "aide1_menu", aide1_menu);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (aide1), aide1_menu);

  a_propos1 = gtk_menu_item_new_with_label (_("About"));
  gtk_object_set_data (GTK_OBJECT (win_main), "a_propos1", a_propos1);
  gtk_widget_show (a_propos1);
  gtk_container_add (GTK_CONTAINER (aide1_menu), a_propos1);

  toolbar1 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_ICONS);
  gtk_object_set_data (GTK_OBJECT (win_main), "toolbar1", toolbar1);
  gtk_widget_show (toolbar1);
  gtk_box_pack_start (GTK_BOX (vbox1), toolbar1, FALSE, FALSE, 0);

  tmp_toolbar_icon = create_pixmap (win_main, "new.xpm");
  btn_nouveau = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                NULL,
                                _("New"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (win_main), "btn_nouveau", btn_nouveau);
  gtk_widget_show (btn_nouveau);

  tmp_toolbar_icon = create_pixmap (win_main, "open.xpm");
  btn_ouvrir = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                NULL,
                                _("Open"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (win_main), "btn_ouvrir", btn_ouvrir);
  gtk_widget_show (btn_ouvrir);

  tmp_toolbar_icon = create_pixmap (win_main, "save.xpm");
  btn_enregister = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                NULL,
                                _("Save"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (win_main), "btn_enregister", btn_enregister);
  gtk_widget_show (btn_enregister);

  // le bouton quitter
  tmp_toolbar_icon = create_pixmap (win_main, "quit.xpm");
  btn_quit = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                NULL,
                                _("Quit"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (win_main), "btn_quit", btn_quit);
  gtk_widget_show (btn_quit);
  
  //le separateur
  gtk_toolbar_append_space(GTK_TOOLBAR(toolbar1));

  tmp_toolbar_icon = create_pixmap (win_main, "deb_cred.xpm");
  btn_operation = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                NULL,
                                _("Add..."), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (win_main), "btn_operation", btn_operation);
  gtk_widget_show (btn_operation);
  //bouton pour le check
  tmp_toolbar_icon = create_pixmap (win_main, "check.xpm");
  btn_check = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                NULL,
                                _("Check"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (win_main), "btn_check", btn_check);
  gtk_widget_show (btn_check);

  //bouton pour la suppression
  tmp_toolbar_icon = create_pixmap (win_main, "del.xpm");
  btn_delete = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                NULL,
                                _("Delete"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (win_main), "btn_delete", btn_delete);
  gtk_widget_show (btn_delete);


  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (win_main), "scrolledwindow1", scrolledwindow1);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 0);
  gtk_widget_set_usize (scrolledwindow1, 300, 130);

  list_op = gtk_clist_new (7);
  gtk_object_set_data (GTK_OBJECT (win_main), "list_op", list_op);
  gtk_widget_show (list_op);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), list_op);
  gtk_widget_set_usize (list_op, 300, 130);
  gtk_clist_set_column_width (GTK_CLIST (list_op), 0, 86);
  gtk_clist_set_column_width (GTK_CLIST (list_op), 1, 224);
  gtk_clist_set_column_width (GTK_CLIST (list_op), 2, 50);
  gtk_clist_set_column_width (GTK_CLIST (list_op), 3, 50);
  gtk_clist_set_column_width (GTK_CLIST (list_op), 4, 75);
  gtk_clist_set_column_width (GTK_CLIST (list_op), 5, 70);
  gtk_clist_set_column_width (GTK_CLIST (list_op), 6, 10);
  gtk_clist_column_titles_show (GTK_CLIST (list_op));

  lbl_date = gtk_label_new (_("Date"));
  gtk_object_set_data (GTK_OBJECT (win_main), "lbl_date", lbl_date);
  gtk_widget_show (lbl_date);
  gtk_clist_set_column_widget (GTK_CLIST (list_op), 0, lbl_date);

  lbl_libel = gtk_label_new (_("Description"));
  gtk_object_set_data (GTK_OBJECT (win_main), "lbl_libel", lbl_libel);
  gtk_widget_show (lbl_libel);
  gtk_clist_set_column_widget (GTK_CLIST (list_op), 1, lbl_libel);

  lbl_debit = gtk_label_new (_("Debit"));
  gtk_object_set_data (GTK_OBJECT (win_main), "lbl_debit", lbl_debit);
  gtk_widget_show (lbl_debit);
  gtk_clist_set_column_widget (GTK_CLIST (list_op), 2, lbl_debit);

  lbl_credit = gtk_label_new (_("Credit"));
  gtk_object_set_data (GTK_OBJECT (win_main), "lbl_credit", lbl_credit);
  gtk_widget_show (lbl_credit);
  gtk_clist_set_column_widget (GTK_CLIST (list_op), 3, lbl_credit);

  lbl_type = gtk_label_new (_("Chk #"));
  gtk_object_set_data (GTK_OBJECT (win_main), "lbl_type", lbl_type);
  gtk_widget_show (lbl_type);
  gtk_clist_set_column_widget (GTK_CLIST (list_op), 4, lbl_type);

  lbl_solde = gtk_label_new (_("Total"));
  gtk_object_set_data (GTK_OBJECT (win_main), "lbl_solde", lbl_solde);
  gtk_widget_show (lbl_solde);
  gtk_clist_set_column_widget (GTK_CLIST (list_op), 5, lbl_solde);

  lbl_check = gtk_label_new ("C");
  gtk_object_set_data (GTK_OBJECT (win_main), "lbl_check", lbl_check);
  gtk_widget_show (lbl_check);
  gtk_clist_set_column_widget (GTK_CLIST (list_op), 6, lbl_check);
  
  // la bare de status
  statusbar1 = gtk_statusbar_new ();
  gtk_object_set_data (GTK_OBJECT (win_main), "statusbar1", statusbar1);
  gtk_widget_show (statusbar1);
  gtk_box_pack_start (GTK_BOX (vbox1), statusbar1, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (win_main), "delete_event",
                      GTK_SIGNAL_FUNC (on_window1_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (nouveau1), "activate",
                      GTK_SIGNAL_FUNC (on_nouveau1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ouvrir1), "activate",
                      GTK_SIGNAL_FUNC (on_ouvrir1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (enregistrer1), "activate",
                      GTK_SIGNAL_FUNC (on_enregistrer1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (exporter_latex1), "activate",
                      GTK_SIGNAL_FUNC (on_exporter_latex1_activate),
                      list_op);
  gtk_signal_connect (GTK_OBJECT (exporter_html1), "activate",
                      GTK_SIGNAL_FUNC (on_exporter_html1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (quitter1), "activate",
                      GTK_SIGNAL_FUNC (on_quitter1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ajouter_une_op_ration2), "activate",
                      GTK_SIGNAL_FUNC (on_ajouter_une_op_ration2_activate),
                      win_main);
  gtk_signal_connect (GTK_OBJECT (supprimer_operation), "activate",
                      GTK_SIGNAL_FUNC (on_supprimer_operation_activate),
                      win_main);
  gtk_signal_connect (GTK_OBJECT (d_bit_automatique1), "activate",
                      GTK_SIGNAL_FUNC (on_d_bit_automatique1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (cr_dit_automatique1), "activate",
                      GTK_SIGNAL_FUNC (on_cr_dit_automatique1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (a_propos1), "activate",
                      GTK_SIGNAL_FUNC (on_a_propos1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_nouveau), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_nouveau_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_ouvrir), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_ouvrir_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_enregister), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_enregister_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_operation), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_operation_clicked),
                      win_main);
  gtk_signal_connect (GTK_OBJECT (btn_delete),"clicked",
		      GTK_SIGNAL_FUNC (on_btn_delete_clicked),
		      list_op);
  gtk_signal_connect (GTK_OBJECT (btn_check),"clicked",
		      GTK_SIGNAL_FUNC (on_btn_check_clicked),
		      list_op);
  gtk_signal_connect (GTK_OBJECT (exporter_csv), "activate",
                      GTK_SIGNAL_FUNC (on_exporter_csv_activate),
                      list_op);
  gtk_signal_connect (GTK_OBJECT (check_operation), "activate",
                      GTK_SIGNAL_FUNC (on_check_operation_activate),
                      list_op);


  return win_main;
}







