#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "interface.h"
#include "callbacks.h"
#include "support.h"


GtkWidget*
create_dlg_message ()
{
  GtkWidget *dlg_message;
  GtkWidget *dialog_vbox2;
  GtkWidget *hbox6;
  GtkWidget *pixmap1;
  GtkWidget *lbl_info;
  GtkWidget *dialog_action_area2;
  GtkWidget *btn_ok;

  dlg_message = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (dlg_message), "dlg_message", dlg_message);
  GTK_WINDOW (dlg_message)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_title (GTK_WINDOW (dlg_message), "Message :");
  gtk_window_set_policy (GTK_WINDOW (dlg_message), TRUE, TRUE, FALSE);

  dialog_vbox2 = GTK_DIALOG (dlg_message)->vbox;
  gtk_object_set_data (GTK_OBJECT (dlg_message), "dialog_vbox2", dialog_vbox2);
  gtk_widget_show (dialog_vbox2);

  hbox6 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (dlg_message), "hbox6", hbox6);
  gtk_widget_show (hbox6);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2), hbox6, FALSE, FALSE, 0);

  pixmap1 = create_pixmap (dlg_message, "attention.xpm");
  gtk_object_set_data (GTK_OBJECT (dlg_message), "pixmap1", pixmap1);
  gtk_widget_show (pixmap1);
  gtk_box_pack_start (GTK_BOX (hbox6), pixmap1, TRUE, TRUE, 0);
  gtk_widget_set_usize (pixmap1, 70, -2);

  lbl_info = gtk_label_new ("");
  gtk_object_set_data (GTK_OBJECT (dlg_message), "lbl_info", lbl_info);
  gtk_widget_show (lbl_info);
  gtk_box_pack_start (GTK_BOX (hbox6), lbl_info, FALSE, FALSE, 0);
  gtk_widget_set_usize (lbl_info, 200, 51);

  dialog_action_area2 = GTK_DIALOG (dlg_message)->action_area;
  gtk_object_set_data (GTK_OBJECT (dlg_message), "dialog_action_area2", dialog_action_area2);
  gtk_widget_show (dialog_action_area2);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area2), 10);

  btn_ok = gtk_button_new_with_label ("OK");
  gtk_object_set_data (GTK_OBJECT (dlg_message), "btn_ok", btn_ok);
  gtk_widget_show (btn_ok);
  gtk_box_pack_start (GTK_BOX (dialog_action_area2), btn_ok, FALSE, FALSE, 0);
  gtk_widget_set_usize (btn_ok, 70, 25);

  gtk_signal_connect (GTK_OBJECT (btn_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_ok2_clicked),
                      dlg_message);

  gtk_grab_add(dlg_message);

  return dlg_message;
}

