#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "interface.h"
#include "callbacks.h"
#include "support.h"


GtkWidget*
create_win_saisie (GtkWidget *ptr_win_main)
{
  GtkWidget *win_saisie;
  GtkWidget *vbox2;
  GtkWidget *frame3;
  GtkWidget *vbox4;
  GSList *grp_typ_group = NULL;
  GtkWidget *radio_debit;
  GtkWidget *radio_credit;
  GtkWidget *hbox2;
  GtkWidget *label1;
  GtkWidget *txt_montant;
  GtkWidget *label3;
  GtkWidget *hbox4;
  GtkWidget *label4;
  GtkWidget *entry2;
  GtkWidget *frame2;
  GtkWidget *calendrier;
  GtkWidget *frame1;
  GtkWidget *vbox3;
  GtkWidget *hbox3;
  GSList *grp_pay_group = NULL;
  GtkWidget *radio_cheque;
  GtkWidget *label2;
  GtkObject *spin_numero_adj;
  GtkWidget *spin_numero;
  GtkWidget *radio_carte;
  GtkWidget *radio_vers_prel;
  GtkWidget *hbox5;
  GtkWidget *btn_ok;
  GtkWidget *btn_annuler;

  win_saisie = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (win_saisie), "win_saisie", win_saisie);
  gtk_window_set_title (GTK_WINDOW (win_saisie), _("Enter Operation"));

  vbox2 = gtk_vbox_new (FALSE, 10);
  gtk_object_set_data (GTK_OBJECT (win_saisie), "vbox2", vbox2);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (win_saisie), vbox2);
  gtk_container_set_border_width (GTK_CONTAINER (vbox2), 10);

  frame3 = gtk_frame_new (_("Sort of Operation"));
  gtk_object_set_data (GTK_OBJECT (win_saisie), "frame3", frame3);
  gtk_widget_show (frame3);
  gtk_box_pack_start (GTK_BOX (vbox2), frame3, TRUE, TRUE, 0);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (win_saisie), "vbox4", vbox4);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (frame3), vbox4);

  radio_debit = gtk_radio_button_new_with_label (grp_typ_group, _("debit on account"));
  grp_typ_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_debit));
  gtk_object_set_data (GTK_OBJECT (win_saisie), "radio_debit", radio_debit);
  gtk_widget_show (radio_debit);
  gtk_box_pack_start (GTK_BOX (vbox4), radio_debit, FALSE, FALSE, 0);

  radio_credit = gtk_radio_button_new_with_label (grp_typ_group, _("credit on account"));
  grp_typ_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_credit));
  gtk_object_set_data (GTK_OBJECT (win_saisie), "radio_credit", radio_credit);
  gtk_widget_show (radio_credit);
  gtk_box_pack_start (GTK_BOX (vbox4), radio_credit, FALSE, FALSE, 0);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (win_saisie), "hbox2", hbox2);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox2, TRUE, TRUE, 0);

  label1 = gtk_label_new (_("amount of operation :"));
  gtk_object_set_data (GTK_OBJECT (win_saisie), "label1", label1);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (hbox2), label1, FALSE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (label1), 22, 0);

  txt_montant = gtk_entry_new_with_max_length (10);
  gtk_object_set_data (GTK_OBJECT (win_saisie), "txt_montant", txt_montant);
  gtk_widget_show (txt_montant);
  gtk_box_pack_start (GTK_BOX (hbox2), txt_montant, TRUE, TRUE, 0);

  label3 = gtk_label_new (_("Dollars"));
  gtk_object_set_data (GTK_OBJECT (win_saisie), "label3", label3);
  gtk_widget_show (label3);
  gtk_box_pack_start (GTK_BOX (hbox2), label3, FALSE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (label3), 4, 0);

  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (win_saisie), "hbox4", hbox4);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox4, TRUE, TRUE, 0);

  label4 = gtk_label_new (_("Description :"));
  gtk_object_set_data (GTK_OBJECT (win_saisie), "label4", label4);
  gtk_widget_show (label4);
  gtk_box_pack_start (GTK_BOX (hbox4), label4, FALSE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (label4), 20, 0);

  entry2 = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (win_saisie), "entry2", entry2);
  gtk_widget_show (entry2);
  gtk_box_pack_start (GTK_BOX (hbox4), entry2, TRUE, TRUE, 0);

  frame2 = gtk_frame_new (_(" Date of operation "));
  gtk_object_set_data (GTK_OBJECT (win_saisie), "frame2", frame2);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (vbox2), frame2, TRUE, TRUE, 0);

  calendrier = gtk_calendar_new ();
  gtk_object_set_data (GTK_OBJECT (win_saisie), "calendrier", calendrier);
  gtk_widget_show (calendrier);
  gtk_container_add (GTK_CONTAINER (frame2), calendrier);
  gtk_calendar_display_options (GTK_CALENDAR (calendrier),
                                GTK_CALENDAR_SHOW_HEADING
                                | GTK_CALENDAR_SHOW_DAY_NAMES);

  frame1 = gtk_frame_new (_(" type of payment "));
  gtk_object_set_data (GTK_OBJECT (win_saisie), "frame1", frame1);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (vbox2), frame1, TRUE, TRUE, 0);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (win_saisie), "vbox3", vbox3);
  gtk_widget_show (vbox3);
  gtk_container_add (GTK_CONTAINER (frame1), vbox3);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (win_saisie), "hbox3", hbox3);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox3), hbox3, TRUE, TRUE, 0);

  radio_cheque = gtk_radio_button_new_with_label (grp_pay_group, _("Cheque"));
  grp_pay_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_cheque));
  gtk_object_set_data (GTK_OBJECT (win_saisie), "radio_cheque", radio_cheque);
  gtk_widget_show (radio_cheque);
  gtk_box_pack_start (GTK_BOX (hbox3), radio_cheque, FALSE, FALSE, 0);

  label2 = gtk_label_new (_("N of the Cheque"));
  gtk_object_set_data (GTK_OBJECT (win_saisie), "label2", label2);
  gtk_widget_show (label2);
  gtk_box_pack_start (GTK_BOX (hbox3), label2, FALSE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (label2), 12, 0);

  spin_numero_adj = gtk_adjustment_new (5493, 0, 9999, 1, 10, 10);
  spin_numero = gtk_spin_button_new (GTK_ADJUSTMENT (spin_numero_adj), 1, 0);
  gtk_object_set_data (GTK_OBJECT (win_saisie), "spin_numero", spin_numero);
  gtk_widget_show (spin_numero);
  gtk_box_pack_start (GTK_BOX (hbox3), spin_numero, FALSE, FALSE, 0);
  gtk_widget_set_usize (spin_numero, 53, -2);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spin_numero), TRUE);
  gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spin_numero), TRUE);

  radio_carte = gtk_radio_button_new_with_label (grp_pay_group, _("Bank Card"));
  grp_pay_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_carte));
  gtk_object_set_data (GTK_OBJECT (win_saisie), "radio_carte", radio_carte);
  gtk_widget_show (radio_carte);
  gtk_box_pack_start (GTK_BOX (vbox3), radio_carte, FALSE, FALSE, 0);

  radio_vers_prel = gtk_radio_button_new_with_label (grp_pay_group, _("Payment or Taking away"));
  grp_pay_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_vers_prel));
  gtk_object_set_data (GTK_OBJECT (win_saisie), "radio_vers_prel", radio_vers_prel);
  gtk_widget_show (radio_vers_prel);
  gtk_box_pack_start (GTK_BOX (vbox3), radio_vers_prel, FALSE, FALSE, 0);

  hbox5 = gtk_hbox_new (TRUE, 0);
  gtk_object_set_data (GTK_OBJECT (win_saisie), "hbox5", hbox5);
  gtk_widget_show (hbox5);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox5, TRUE, TRUE, 0);

  btn_ok = gtk_button_new_with_label (_("Next"));
  gtk_object_set_data (GTK_OBJECT (win_saisie), "btn_ok", btn_ok);
  gtk_widget_show (btn_ok);
  gtk_box_pack_start (GTK_BOX (hbox5), btn_ok, FALSE, FALSE, 0);
  gtk_widget_set_usize (btn_ok, 70, 25);

  btn_annuler = gtk_button_new_with_label (_("Cancel"));
  gtk_object_set_data (GTK_OBJECT (win_saisie), "btn_annuler", btn_annuler);
  gtk_widget_show (btn_annuler);
  gtk_box_pack_start (GTK_BOX (hbox5), btn_annuler, FALSE, FALSE, 0);
  gtk_widget_set_usize (btn_annuler, 70, 25);

  gtk_signal_connect (GTK_OBJECT (win_saisie), "delete_event",
                      GTK_SIGNAL_FUNC (on_win_saisie_delete_event),
                      win_saisie);
  gtk_signal_connect (GTK_OBJECT (radio_debit), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_debit_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radio_credit), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_credit_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radio_cheque), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_cheque_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radio_carte), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_carte_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_ok_clicked),
                      ptr_win_main);
  gtk_signal_connect (GTK_OBJECT (btn_annuler), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_annuler_clicked),
                      win_saisie);
  gtk_signal_connect (GTK_OBJECT (txt_montant), "insert_text",
                      GTK_SIGNAL_FUNC (insert_text_handler),
                      NULL);
  gtk_grab_add(win_saisie);
  return win_saisie;
}


